/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * TNTMode defines what TNT Explosions should destroy in a Region
 */
@Getter
@AllArgsConstructor
public enum TNTMode implements Flag.Value<TNTMode> {

    ALLOW("FLAG_TNT_ALLOW"),
    DENY("FLAG_TNT_DENY"),
    ONLY_TB("FLAG_TNT_ONLY_TB");

    private static TNTMode[] values;
    private final String chatValue;

    @Override
    public TNTMode[] getValues() {
        if (TNTMode.values == null) {
            TNTMode.values = TNTMode.values();
        }
        return TNTMode.values;
    }

    @Override
    public TNTMode getValue() {
        return this;
    }

    @Override
    public TNTMode getValueOf(final String name) {
        try {
            return TNTMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            return TNTMode.ALLOW;
        }
    }
}